/*------------------------------------------------*/
/* 25daemon/pidfile.c                             */
#include <errno.h>
#include <sys/file.h>
#include <unistd.h>
#include "pidfile.h"

static FILE *pidfile;

int openPidFile(char *filename)
{
    pid_t oldpid = 0;
    int ret;

    pidfile = fopen(filename, "a+");
    if (!pidfile) {
        perror("fopen");
        return 2;
    }

    ret = flock(fileno(pidfile), LOCK_EX);
    if (ret) {
        perror("flock");
        return 2;
    }

    ret = fscanf(pidfile, "%u", &oldpid);
    if (errno != 0) {
        perror("fscanf");
        return 2;
    }

    if (ret >= 0 && oldpid != getpid()) {
        fprintf(stderr, "Demon už běží. PID = %i\n", oldpid);
        return 1;
    }
    return 0;
}

void closePidFile()
{
    fprintf(pidfile, "%d", getpid());
    fclose(pidfile);
}

int removePidFile(char *filename)
{
    return unlink(filename);
}

/*------------------------------------------------*/
