/*------------------------------------------------*/
/* 29postgresql/select1.c                         */
#include <libpq-fe.h>
#include <string.h>
#include "pg-utils.h"

int main(int argc, char **argv)
{
    PGresult *res;
    ExecStatusType status;
    PGconn *conn = pgconnect(argc, argv);
    if (conn == NULL) {
        return 1;
    }
    printf("Conection OK\n");

    /* SELECT */
    const char *values[] = { "1" };
    res = PQexecParams(conn,
               "SELECT * FROM databases WHERE config_id = $1",
               1, NULL, values, NULL, NULL, 0);
    status = printStatus(res);
    if (status != PGRES_TUPLES_OK) {
        return 1;
    }

    /* PRINT result */
    PQprintOpt opt;
    memset(&opt, 0, sizeof(opt));
    opt.header = 1;
    opt.align = 1;
    opt.html3 = 0;
    opt.expanded = 0;
    opt.fieldSep = " | ";
    PQprint(stdout, res, &opt);

    /* PRINT info */
    int r, c, f;
    r = PQntuples(res);    /* pocet radek */
    c = PQnfields(res);    /* pocet sloupcu */
    printf("\n");
    printf("rows x columns = %i x %i\n", r, c);
    printf("position\tname\t\ttype\tsize\n");
    for (f = 0; f < c; f++) {
        printf("%8i", f);
        printf("\t%-10s", PQfname(res, f));
        printf("\t%i", PQftype(res, f));
        printf("\t%4i", PQfsize(res, f));
        printf("\n");
    }

    PQclear(res);
    PQfinish(conn);
    return 0;
}

/*------------------------------------------------*/
