/*------------------------------------------------*/
/* 43internetFunkce/print-hostent.c               */
#include <stdio.h>
#include "print-hostent.h"

char *h_addr_to_string(char *addr, int len)
{
    static char ip4[16];
    if (len != 4)
        return "";

    sprintf(ip4, "%u.%u.%u.%u",
        (unsigned char)addr[0],
        (unsigned char)addr[1],
        (unsigned char)addr[2], (unsigned char)addr[3]);
    return ip4;
}

void printHostent(struct hostent *server)
{
    size_t i;
    printf("Oficiální jméno hosta:\n\t%s\n", server->h_name);
    printf("Aliasy:\n");
    i = 0;
    while (server->h_aliases[i]) {
        printf("\t%s\n", server->h_aliases[i]);
        i++;
    }
    printf("Typ adresy IpV4: %s\n",
           server->h_addrtype == AF_INET ? "yes" : "no");
    printf("Délka adresy v bajtech: %i\n", server->h_length);

    printf("Seznam adres:\n");
    i = 0;
    while (server->h_addr_list[i]) {
        printf("\t%s\n",
               h_addr_to_string(server->h_addr_list[i],
                    server->h_length));
        if (i == 0) {
            printf("\t (= %s)\n",
                   h_addr_to_string(server->h_addr,
                        server->h_length));
        }
        i++;
    }
}
/*------------------------------------------------*/
