/*------------------------------------------------*/
/* 50terminal/isatty.c                            */
#include <string.h>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>

int main(void)
{
    FILE *input, *output;
    char tmp[80];

    input = fopen("/dev/tty", "r");
    output = fopen("/dev/tty", "w");

    if (!input || !output) {
        fprintf(stderr,
            "Nelze otevřít /dev/tty pro čtení nebo zápis.\n");
        return EXIT_FAILURE;
    }

    if (!isatty(fileno(stdin))) {
        fprintf(output,
            "stdin neni připojeno k terminálu, končím!\n");
        return EXIT_FAILURE;
    }

    if (!isatty(fileno(stdout))) {
        fprintf(output,
            "stdout neni připojeno k terminálu, končím!\n");
        return EXIT_FAILURE;
    }

    if (!isatty(fileno(stderr))) {
        fprintf(output,
            "stderr neni připojeno k terminálu, končím!\n");
        return EXIT_FAILURE;
    }

    fprintf(output, "OK, můžeme pracovat :-)\n");
    fprintf(stdout, "Něco mi řekni: ");
    fflush(stdout);
    fgets(tmp, sizeof(tmp), input);
    tmp[strlen(tmp) - 1] = '\0';    /* odstranim znak konce radku '\n' */
    fprintf(output, "\"%s\" říkáš?\nKončím!\n", tmp);

    return EXIT_FAILURE;
}

/*------------------------------------------------*/
